## advligorts 5.5.3

=== src/pub_sub_stream/CMakeLists.txt ===
Message("libcds-pubsub_FOUND = ${libcds-pubsub_FOUND}")
if (libcds-pubsub_FOUND)
    add_subdirectory(plugins)

    add_executable(cps_xmit
            pub_xmit.cc
            )
    target_include_directories(cps_xmit PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../include)
    target_link_libraries(cps_xmit PUBLIC
            driver::shmem
            pv::simple_pv
            simpleargs
            cds::pub_sub
            pub_sub_plugins
            )
    target_requires_cpp11(cps_xmit PUBLIC)

    add_executable(cps_xmit_asan
            pub_xmit.cc
            )
    target_include_directories(cps_xmit_asan PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../include)
    target_link_libraries(cps_xmit_asan PUBLIC
            driver::shmem
            pv::simple_pv
            simpleargs
            cds::pub_sub_asan
            pub_sub_plugins
    )
    target_requires_cpp11(cps_xmit_asan PUBLIC)


    add_executable(cps_recv
            sub_recv_bufferred.cc
            recv_buffer.cc
            cps_recv_admin.cc
            dc_stats.cc
            )
    target_include_directories(cps_recv PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../include
            ${CMAKE_CURRENT_BINARY_DIR}
            ${Boost_INCLUDE_DIRS}
            ${CMAKE_CURRENT_SOURCE_DIR}/../daqd)
    target_link_libraries(cps_recv PUBLIC
            driver::shmem
            pv::simple_pv
            simpleargs
            cds::pub_sub
            driver::ini_parsing
            pub_sub_plugins
            crc32
            )
    target_requires_cpp11(cps_recv PUBLIC)

    add_executable(cps_recv_asan
            sub_recv_bufferred.cc
            recv_buffer.cc
            cps_recv_admin.cc
            dc_stats.cc
            )
    target_include_directories(cps_recv_asan PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../include
            ${CMAKE_CURRENT_BINARY_DIR}
            ${Boost_INCLUDE_DIRS}
            ${CMAKE_CURRENT_SOURCE_DIR}/../daqd)
    target_link_libraries(cps_recv_asan PUBLIC
            driver::shmem
            pv::simple_pv
            simpleargs
            cds::pub_sub_asan
            driver::ini_parsing
            pub_sub_plugins
            crc32)
    target_requires_cpp11(cps_recv_asan PUBLIC)

    add_executable(cds_pub_sub
            cds_pub_sub.cc
            recv_buffer.cc
            )
    target_include_directories(cds_pub_sub PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../src/include
            ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries(cds_pub_sub PUBLIC
            pv::simple_pv
            simpleargs
            cds::pub_sub
            pub_sub_plugins
            driver::shmem)
    target_requires_cpp11(cds_pub_sub PUBLIC)

#    add_executable(cds_pub_sub_asan
#            cds_pub_sub.cc
#            recv_buffer.cc
#            )
#    target_include_directories(cds_pub_sub_asan PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../asan/include
#            ${CMAKE_CURRENT_BINARY_DIR})
#    target_link_libraries(cds_pub_sub_asan PUBLIC
#            pv::simple_pv
#            simpleargs
#            cds::pub_sub_asan
#            sub_plugin_rmipc)
#    target_requires_cpp11(cds_pub_sub_asan PUBLIC)

    add_executable(test_buffer_entry tests/test_buffer_entry.cc)
    target_include_directories(test_buffer_entry PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}
            ${CMAKE_CURRENT_BINARY_DIR}
            ${CMAKE_CURRENT_SOURCE_DIR}/../include)
    target_requires_cpp11(test_buffer_entry PUBLIC)

    add_executable(test_pub_sub_stream_unit_tests
            tests/test_main.cc
            tests/test_message_queue.cc
            tests/test_dc_stats.cc
            tests/test_rmipc_details.cc
            dc_stats.cc)
    target_include_directories(test_pub_sub_stream_unit_tests PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}
            ${CMAKE_CURRENT_SOURCE_DIR}/../include
            ${CMAKE_CURRENT_SOURCE_DIR}/../daqd
            ${Boost_INCLUDE_DIRS})
    target_link_libraries(test_pub_sub_stream_unit_tests PUBLIC
            catch2
            pv::simple_pv
            driver::ini_parsing
            crc32
            pub_sub_plugins
            ${CMAKE_THREAD_LIBS_INIT})

    configure_file(test_pub_sub_xmit_recv.sh.in test_pub_sub_xmit_recv.sh @ONLY)
    configure_file(test_pub_sub_xmit_recv_posix_shmem.sh.in test_pub_sub_xmit_recv_posix_shmem.sh @ONLY)
    configure_file(test_pub_sub_xmit_recv_zstd.sh.in test_pub_sub_xmit_recv_zstd.sh @ONLY)
    configure_file(test_pub_sub.sh.in test_pub_sub.sh @ONLY)
    configure_file(test_pub_sub_posix_shmem.sh.in test_pub_sub_posix_shmem.sh @ONLY)
    configure_file(test_pub_sub_rmipc_to_daqm.sh.in test_pub_sub_rmipc_to_daqm.sh @ONLY)
    configure_file(test_pub_sub_rmipc_to_daqm_posix_shmem.sh.in test_pub_sub_rmipc_to_daqm_posix_shmem.sh @ONLY)
    configure_file(test_pub_sub_daqm_to_daqm.sh.in test_pub_sub_daqm_to_daqm.sh @ONLY)
    configure_file(test_pub_sub_daqm_to_daqm_posix_shmem.sh.in test_pub_sub_daqm_to_daqm_posix_shmem.sh @ONLY)

    integration_test(

	    NAME test_pub_sub
	    SCRIPT "test_pub_sub.py"

	)
	integration_test(

	    NAME test_pub_sub_daqm_to_daqm
	    SCRIPT "test_pub_sub_daqm_to_daqm.py"

	)
	integration_test(

	    NAME test_pub_sub_rmipc_to_daqm
	    SCRIPT "test_pub_sub_rmipc_to_daqm.py"

	)
	integration_test(

	    NAME test_pub_sub_xmit_recv
	    SCRIPT "test_pub_sub_xmit_recv.py"

	)
    integration_test(
        NAME test_pub_sub_xmit_recv_daqm_to_shmem
        SCRIPT "test_pub_sub_xmit_recv_daqm_to_shmem.py"
    )
	integration_test(

	    NAME test_pub_sub_xmit_recv_zstd
	    SCRIPT "test_pub_sub_xmit_recv_zstd.py"

	)

#    add_test(NAME "test_pub_sub_xmit_recv"
#            COMMAND /bin/bash ./test_pub_sub_xmit_recv.sh
#            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

    add_test(NAME "test_pub_sub_xmit_recv_posix_shmem"
            COMMAND /bin/bash ./test_pub_sub_xmit_recv_posix_shmem.sh
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

#    add_test(NAME "test_pub_sub_xmit_recv_zstd"
#            COMMAND /bin/bash ./test_pub_sub_xmit_recv_zstd.sh
#            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

#    add_test(NAME "test_pub_sub"
#        COMMAND /bin/bash ./test_pub_sub.sh
#        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

    add_test(NAME "test_pub_sub_posix_shmem"
            COMMAND /bin/bash ./test_pub_sub_posix_shmem.sh
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

#    add_test(NAME "test_pub_sub_rmipc_to_daqm"
#        COMMAND /bin/bash ./test_pub_sub_rmipc_to_daqm.sh
#        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

    add_test(NAME "test_pub_sub_rmipc_to_daqm_posix_shmem"
            COMMAND /bin/bash ./test_pub_sub_rmipc_to_daqm_posix_shmem.sh
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

#    add_test(NAME "test_pub_sub_daqm_to_daqm"
#            COMMAND /bin/bash ./test_pub_sub_daqm_to_daqm.sh
#            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

    add_test(NAME "test_pub_sub_daqm_to_daqm_posix_shmem"
            COMMAND /bin/bash ./test_pub_sub_daqm_to_daqm_posix_shmem.sh
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

    add_test(NAME "test_buffer_entry"
            COMMAND test_buffer_entry)


    install(TARGETS cps_xmit DESTINATION bin)
    install(TARGETS cps_recv DESTINATION bin)
    install(TARGETS cds_pub_sub DESTINATION bin)

endif (libcds-pubsub_FOUND)

=== src/simple_pv/CMakeLists.txt ===
add_library(simple_pv STATIC simple_pv.cc
        simple_epics.cc
        simple_pv_internal.cc)
target_include_directories(simple_pv PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(simple_pv PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/private "${CMAKE_CURRENT_SOURCE_DIR}/../include")
target_link_libraries(simple_pv PUBLIC epics::cas epics::gdd /usr/lib/epics/lib/linux-x86_64/libCom.so epics::ca)
target_requires_cpp11(simple_pv PUBLIC)
install(TARGETS simple_pv DESTINATION lib)
install(FILES simple_pv.h simple_epics.hh DESTINATION include/advligorts)
add_library(pv::simple_pv ALIAS simple_pv)

add_library(simple_pv_so SHARED simple_pv.cc
        simple_epics.cc
        simple_pv_internal.cc)
target_include_directories(simple_pv_so PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(simple_pv_so PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/private "${CMAKE_CURRENT_SOURCE_DIR}/../include")
target_link_libraries(simple_pv_so PUBLIC epics::cas epics::gdd /usr/lib/epics/lib/linux-x86_64/libCom.so epics::ca)
target_requires_cpp11(simple_pv_so PUBLIC)

add_executable(test_simple_pv tests/test_simple_pv.cc)
target_link_libraries(test_simple_pv PUBLIC simple_pv)
target_include_directories(test_simple_pv PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(test_rw_ioc tests/test_rw_cas.cc)
target_link_libraries(test_rw_ioc PUBLIC simple_pv)

=== src/simpleargs/CMakeLists.txt ===
add_library(simpleargs STATIC simpleargs.cc)
target_include_directories(simpleargs PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(simpleargs PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/../include")
target_requires_cpp11(simpleargs PRIVATE)
install(TARGETS simpleargs DESTINATION lib)
install(FILES simpleargs.h DESTINATION include)

add_executable(test_args tests/test_main.cc tests/test_args.cc)
target_include_directories(test_args PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/tests)
target_link_libraries(test_args simpleargs catch2)
target_requires_cpp11(test_args PUBLIC)

=== src/epics/edcu/CMakeLists.txt ===
if (Boost_FOUND)

    add_executable(standalone_edc
            standalone_edcu.cc)
    target_include_directories(standalone_edc PUBLIC
            "${CMAKE_CURRENT_SOURCE_DIR}/../../include"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../include/drv"
            ${Boost_INCLUDE_DIRS})
    target_link_libraries(standalone_edc PUBLIC
            simpleargs
            epics::ca
            driver::ini_parsing
            pv::simple_pv
            ${Boost_LIBRARIES}
            ${CMAKE_THREAD_LIBS_INIT}
            driver::gpsclock
            driver::shmem
            cds::pub_sub
            )
    target_requires_cpp11(standalone_edc PUBLIC)

    integration_test(
        NAME test_standalone_edc_live_nds
        SCRIPT "test/test_standalone_edc_live_nds.py"
        RESOURCE "test/daqdrc_standalone_edc_live_test" "tests/epics_test.py"
    )

    integration_test(
        NAME test_standalone_edc_live_pub_sub_nds
        SCRIPT "test/test_standalone_edc_live_pub_sub_nds.py"
        RESOURCE "test/daqdrc_standalone_edc_live_test" "tests/epics_test.py"
    )

    integration_test(
            NAME test_standalone_edc_live_daqm_to_pub_sub_nds
            SCRIPT "test/test_standalone_edc_live_daqm_to_pub_sub_nds.py"
            RESOURCE "test/daqdrc_standalone_edc_live_test" "tests/epics_test.py"
    )

    install(TARGETS standalone_edc DESTINATION bin)

else(Boost_FOUND)
    message(WARNING "The standalone_edc will not be build as boost was not found")
endif (Boost_FOUND)

=== debian/changelog ===
advligorts (5.5.3-1+deb10) stable; urgency=medium

  * Release of 5.5.3

 -- Erik von Reis <evonreis@caltech.edu>  Tue, 20 Jan 2026 11:19:20 -0800

advligorts (5.5.3~dev2-1+deb10) stable; urgency=medium

  * change auto deb release back to master
  * add trixie to autorelease

 -- Erik von Reis <evonreis@caltech.edu>  Thu, 18 Dec 2025 11:45:40 -0800

advligorts (5.5.3~dev1-1+deb10) stable; urgency=medium

  * Make the code build from Debian Buster to Trixie
  * Updates to the mbuf/gpstime/rts-logger drivers to build cleanly under Debian Trixie (Linux 6.12).
  * Updates to the rts-cpu-isolator so that it builds on Linux 6.12
  * Updates to build models on Debian 13 (Trixie) and Linux 6.12.  * Implemented _ligo_class_create for state space control.  * Updated the mydevnode defintion to build with multiple linux versions.  * Adding forwards to remove warnings for functions with no prototype.  * Removed cmake warnings for userspace code by requiring cmake 3.10  * Fixed cmake errors in userspace code by correcting the case of the list(APPEND...) call.  * Removed warnings by moving the 'static' and 'inline' components of function definitions to the left.
  * Update the run number server to support a test/ro interface.
  * Fix to build the run number server on Debian 10.
  * Fixing script so it will only return the first symvers found

 -- Erik von Reis <evonreis@caltech.edu>  Wed, 17 Dec 2025 23:35:07 -0800

=== debian/control ===
Source: advligorts
Section: science
Priority: optional
Maintainer: Jameson Graef Rollins <jameson.rollins@ligo.org>
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 12),
 dkms,
 epics-dev,
 epics-seq-dev,
 flex,
 golang (>= 1.15),
 grace,
 ldas-tools-al-dev,
 ldas-tools-framecpp-dev (<< 2.9),
 ldas-tools-framecpp-dev (>= 2.8.1),
 libboost-all-dev,
 libbz2-dev,
 libc-dev-bin,
 libcds-pubsub-dev (>= 0.3.1),
 libfl-dev,
 libnds2-client-dev,
 libtool,
 pkg-config,
 pybind11-dev,
 rapidjson-dev,
 libzstd-dev,
 python3-pytest,
 libspdlog-dev,
 libfmt-dev,
 libyaml-cpp-dev,
Standards-Version: 4.5.0
Vcs-Git: https://git.ligo.org/cds/advLigoRTS
Rules-Requires-Root: no

Package: advligorts-common
Architecture: all
Depends:
 adduser,
 debconf,
 ${misc:Depends},
Description: advLigoRTS common resources metapackage
 Core component of advLigoRTS.
 .
 Support for other advLigoRTS packages, including creation of the
 'advligorts' user, system config and directories, etc.

Package: advligorts-find-module-symvers
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS build helper for looking up dkms module symvers
 advLigoRTS build helper for looking up dkms module symvers
 .
 You provide the name of a dkms managed module, and this tool will
 lookup the Module.symvers paths for your build.


Package: advligorts-dolphin-daemon
Architecture: any
Depends:
 advligorts-common,
 advligorts-dolphin-proxy-km-dkms,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS dolphin userspace daemon
 Handles netlink messages from real time modules.
 .
 Listens for netlink messages requesting dolphin segment allocations
 and sends them to the advligorts-dolphin-proxy-km-dkms, returning
 that modules messages to the original requestor.

Package: advligorts-mbuf-dkms
Architecture: any
Depends:
 advligorts-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS mbuf kernel module
 Core component of advLigoRTS.
 .
 Memory buffer kernel module.

Package: advligorts-gpstime-dkms
Architecture: any
Depends:
 advligorts-common,
 python3,
 ${misc:Depends},
Description: advLigoRTS gpstime kernel module
 Core component of advLigoRTS.
 .
 GPS card interface kernel module.

Package: advligorts-cpu-isolator-dkms
Architecture: any
Depends:
 ${misc:Depends},
Description: advLigoRTS realtime module.
 Core component of advLigoRTS
 .
 This module provides the hooks needed to run real time LIGO models without requiring a custom built kernel.

Package: advligorts-logger-dkms
Architecture: any
Depends:
 ${misc:Depends},
Description: advLigoRTS isolated cpu logger module.
 Core component of advLigoRTS
 .
 This module provides logging capabilities to real time isolated kernel modules.

Package: advligorts-dolphin-proxy-km-dkms
Architecture: any
Depends:
 advligorts-find-module-symvers,
 ${misc:Depends},
Description: advLigoRTS dolphin node interface module.
 Core component of advLigoRTS dolphin nodes
 .
 This module provides a netlink interface to interact with the Dolphin kernel space interface


Package: advligorts-daqd
Architecture: any
Depends:
 advligorts-common,
 advligorts-mbuf-dkms,
 ldas-tools-framecpp (<< 2.9),
 ldas-tools-framecpp (>= 2.8.1),
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS daqd binaries
 Core component of advLigoRTS.
 .
 Binaries for acquiring data from front ends, writing frames, and
 serving data via NDS.

Package: advligorts-simulated-streams
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Daqd debug applications used to create simulated data
 streams and verify those streams.
 .
 Used for debugging of the daqd and its data stream.

Package: advligorts-rcg
Architecture: any
Depends:
 adduser,
 advligorts-common,
 advligorts-gpstime-dkms,
 advligorts-mbuf-dkms,
 advligorts-logger-dkms,
 autoconf,
 dkms,
 epics-seq-dev,
 libncurses5-dev,
 libswitch-perl,
 make,
 pkg-config,
 python3,
 python3-rtcds (>= 6),
 tcsh,
 git,
 cmake,
 catch,
 pybind11-dev,
 libspdlog-dev,
 libjson-perl,
 ${misc:Depends},
 ${perl:Depends},
Recommends:
 advligorts-fe,
Description: advLigoRTS real-time code generator (RCG)
 Core component of advLigoRTS.
 .
 Real-time Code Generator system for building real-time signal
 processing kernel modules from Simulink description graphs.

Package: advligorts-fe
Architecture: any
Depends:
 advligorts-awgtpman,
 advligorts-common,
 advligorts-edc,
 advligorts-gpstime-dkms,
 advligorts-local-dc,
 advligorts-mbuf-dkms,
 python3-rtcds (>= 6),
 rtcds-frontend-startup (>= 6),
 sudo,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 advligorts-rcg (<< 4.0.0~dev0),
Description: advLigoRTS front end support
 Core component of advLigoRTS.
 .
 Binaries and systemd services for advLigoRTS front end systems.

Package: advligorts-local-dc
Architecture: any
Depends:
 advligorts-common,
 advligorts-gpstime-dkms,
 advligorts-mbuf-dkms,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS local data concentrator
 Core component of advLigoRTS.
 .
 Binaries and systemd services to support concentrating LIGO
 front end data into a single buffer for transmission.

Package: advligorts-awgtpman
Architecture: any
Depends:
 advligorts-common,
 advligorts-gpstime-dkms,
 advligorts-mbuf-dkms,
 rpcbind,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS waveform generator and test point manager.
 Core component of advLigoRTS.
 .
 Binaries and systemd services for the advLigoRTS front end system.
 Awgtpman is the interface which interacts with the LIGO front end
 systems to enable test points and injections.

Package: advligorts-edc
Architecture: any
Depends:
 advligorts-common,
 advligorts-gpstime-dkms,
 advligorts-local-dc,
 advligorts-mbuf-dkms,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS EPICS data collection software.
 Core component of advLigoRTS.
 .
 Binaries and systemd services for the advLigoRTS system.  The
 edc collects EPICS channels and stores them in a shared memory
 buffer that can be consumed by the advLigoRTS daqd systems.

Package: advligorts-transport-common
Architecture: all
Depends:
 advligorts-common,
 advligorts-gpstime-dkms,
 advligorts-mbuf-dkms,
 ${misc:Depends},
Description: advLigoRTS transport common metapackage
 Core component of advLigoRTS.
 .
 Common systemd units and dependencies for transport services.

Package: advligorts-transport-pubsub
Architecture: any
Depends:
 advligorts-transport-common,
 libcds-pubsub (>= 0.3.1),
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS pub/sub based transport
 Core component of advLigoRTS.
 .
 IP-based pub/sub network transport for advLigoRTS DAQD structures.

Package: advligorts-cymac
Architecture: all
Depends:
 advligorts-daqd,
 advligorts-fe,
 advligorts-rcg,
 psmisc,
 ${misc:Depends},
Recommends:
 cds-workstation,
Description: advLigoRTS stand-alone "CYMAC" metapackage
 Advanced LIGO data acquisition system, stand-alone version.

Package: python3-ligo-shmem
Architecture: any
Depends:
 python3,
 ${misc:Depends},
Recommends:
 advligorts-mbuf-dkms,
Description: Python library for opening and accessing the LIGO mbuf and posix shmem buffers.

Package: advligorts-dev
Architecture: any
Description: Development files for advligorts
 Header files for use in projects that share data structures with advligorts.

Package: advligorts-trend-utils
Architecture: any
Depends:
 ldas-tools-framecpp (<< 2.9),
 ldas-tools-framecpp (>= 2.8.1),
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS raw trend utils for verification and manipulation of raw trends.

Package: libsimpleargs-dev
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: A simple commandline argument parser for C++.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = t

SVERSION := $(shell dpkg-parsechangelog --show-field=Version | rev | cut -d- -f2- | rev)

%:
	dh $@ --builddirectory=build --with dkms


install-mbuf:
	dh_installdirs -padvligorts-mbuf-dkms usr/src/mbuf-$(SVERSION)
	dh_installdirs -padvligorts-mbuf-dkms lib/udev/rules.d
	dh_installdirs -padvligorts-mbuf-dkms usr/lib/modules-load.d
	install --mode=644 -t debian/advligorts-mbuf-dkms/usr/src/mbuf-$(SVERSION) src/drv/mbuf/*.c
	install --mode=644 -t debian/advligorts-mbuf-dkms/usr/src/mbuf-$(SVERSION) src/drv/mbuf/*.h
	install --mode=644 -t debian/advligorts-mbuf-dkms/usr/src/mbuf-$(SVERSION) src/drv/mbuf/Makefile
	install --mode=755 -t debian/advligorts-mbuf-dkms/usr/src/mbuf-$(SVERSION) support/bin/dkms_install_files
	sed 's|__SHARE__|/usr/share/advligorts|' <support/udev/mbuf.rules >debian/advligorts-mbuf-dkms/lib/udev/rules.d/60-mbuf.rules
	echo mbuf > debian/advligorts-mbuf-dkms/usr/lib/modules-load.d/mbuf.conf

install-gpstime:
	dh_installdirs -padvligorts-gpstime-dkms usr/src/gpstime-$(SVERSION)/drv/gpstime
	dh_installdirs -padvligorts-gpstime-dkms usr/src/gpstime-$(SVERSION)/include/drv
	dh_installdirs -padvligorts-gpstime-dkms usr/src/gpstime-$(SVERSION)/include/util
	dh_installdirs -padvligorts-gpstime-dkms usr/src/gpstime-$(SVERSION)/drv/rts-logger/force-printk/
	dh_installdirs -padvligorts-gpstime-dkms lib/udev/rules.d
	dh_installdirs -padvligorts-gpstime-dkms usr/lib/modules-load.d
	dh_installdirs -padvligorts-gpstime-dkms usr/share/advligorts
	dh_installdirs -padvligorts-gpstime-dkms sbin
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/drv/gpstime src/drv/gpstime/*.c
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/drv/gpstime src/drv/gpstime/*.h
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/drv/gpstime src/drv/gpstime/Makefile
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/include/drv src/include/drv/*.c
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/include/drv src/include/drv/*.h
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/include/util src/include/util/*.h
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/include/ src/include/proc.h
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/include/ src/include/portableInline.h
	install --mode=644 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION)/drv/rts-logger/force-printk/ src/drv/rts-logger/force-printk/printk-rts-logger.c
	install --mode=755 -t debian/advligorts-gpstime-dkms/usr/src/gpstime-$(SVERSION) support/bin/dkms_install_files
	install --mode=755 src/drv/gpstime/gpstime_module_config/gpstime_module_config.py debian/advligorts-gpstime-dkms/sbin/gpstime_module_config
	install --mode=644 support/udev/gpstime.rules debian/advligorts-gpstime-dkms/lib/udev/rules.d/60-gpstime.rules
	echo gpstime > debian/advligorts-gpstime-dkms/usr/lib/modules-load.d/gpstime.conf

install-rts-cpu-isolator:
	dh_installdirs -padvligorts-cpu-isolator-dkms usr/src/rts-cpu-isolator-$(SVERSION)
	dh_installdirs -padvligorts-cpu-isolator-dkms usr/lib/modules-load.d
	install --mode=644 -t debian/advligorts-cpu-isolator-dkms/usr/src/rts-cpu-isolator-$(SVERSION) src/drv/rts-cpu-isolator/*.c
	install --mode=644 -t debian/advligorts-cpu-isolator-dkms/usr/src/rts-cpu-isolator-$(SVERSION) src/drv/rts-cpu-isolator/*.h
	install --mode=644 -t debian/advligorts-cpu-isolator-dkms/usr/src/rts-cpu-isolator-$(SVERSION) src/drv/rts-cpu-isolator/Makefile
	install --mode=755 -t debian/advligorts-cpu-isolator-dkms/usr/src/rts-cpu-isolator-$(SVERSION) support/bin/dkms_install_files
	echo rts-cpu-isolator > debian/advligorts-cpu-isolator-dkms/usr/lib/modules-load.d/rts-cpu-isolator.conf

install-rts-logger:
	dh_installdirs -padvligorts-logger-dkms usr/src/rts-logger-$(SVERSION)
	dh_installdirs -padvligorts-logger-dkms usr/src/rts-logger-$(SVERSION)/drv/
	dh_installdirs -padvligorts-logger-dkms usr/lib/modules-load.d
	install --mode=644 -t debian/advligorts-logger-dkms/usr/src/rts-logger-$(SVERSION) src/drv/rts-logger/module/*.c
	install --mode=644 -t debian/advligorts-logger-dkms/usr/src/rts-logger-$(SVERSION)/drv src/include/drv/rts-logger.h
	install --mode=644 -t debian/advligorts-logger-dkms/usr/src/rts-logger-$(SVERSION) src/drv/rts-logger/module/Makefile
	install --mode=755 -t debian/advligorts-logger-dkms/usr/src/rts-logger-$(SVERSION) support/bin/dkms_install_files
	echo rts-logger > debian/advligorts-logger-dkms/usr/lib/modules-load.d/rts-logger.conf

install-advligorts-dolphin-proxy-km:
	dh_installdirs -padvligorts-dolphin-proxy-km-dkms usr/src/dolphin-proxy-km-$(SVERSION)
	dh_installdirs -padvligorts-dolphin-proxy-km-dkms usr/src/dolphin-proxy-km-$(SVERSION)/util/
	dh_installdirs -padvligorts-dolphin-proxy-km-dkms usr/lib/modules-load.d
	install --mode=644 -t debian/advligorts-dolphin-proxy-km-dkms/usr/src/dolphin-proxy-km-$(SVERSION) src/dolphin_daemon/dolphin_proxy_km/*
	install --mode=644 -t debian/advligorts-dolphin-proxy-km-dkms/usr/src/dolphin-proxy-km-$(SVERSION) src/dolphin_daemon/include/daemon_messages.h
	install --mode=644 -t debian/advligorts-dolphin-proxy-km-dkms/usr/src/dolphin-proxy-km-$(SVERSION)/util/ src/include/util/fixed_width_types.h
	install --mode=644 -t debian/advligorts-dolphin-proxy-km-dkms/usr/src/dolphin-proxy-km-$(SVERSION) support/bin/dkms_install_files


install-version:
	mkdir -p debian/advligorts-rcg/usr/share/advligorts/src/
	echo $(SVERSION) > debian/advligorts-rcg/usr/share/advligorts/src/rcg-version
	git rev-parse HEAD > debian/advligorts-rcg/usr/share/advligorts/src/rcg_git_hash.txt
	git --no-pager diff > debian/advligorts-rcg/usr/share/advligorts/src/rcg_git_diff.txt


override_dh_auto_configure:
	mkdir -p build
	(cd build && cmake -DCMAKE_INSTALL_PREFIX=$(DESTDIR)/usr ..)

override_dh_install: install-gpstime install-mbuf install-version install-rts-cpu-isolator install-rts-logger install-advligorts-dolphin-proxy-km
	dh_install

override_dh_dkms:
	dh_dkms -V $(SVERSION)

override_dh_auto_test:
	true

override_dh_clean:
	rm -rf build
	dh_clean
